module Dicts
  class Currency < ::Dict
    attr_reader :symbol

    def initialize(id, index, symbol)
      @symbol = symbol
      super(id, index)
    end

    AED = new(17, 'AED', "\u062f.\u0625.")
    ARS = new(9, 'ARS',  "$")
    AUD = new(7, 'AUD',  "$")
    BGN = new(11, 'BGN', "lev")
    BHD = new(10, 'BHD', "\u062f.\u0628.")
    BRL = new(12, 'BRL', "R$")
    CAD = new(25, 'CAD', "$")
    CHF = new(47, 'CHF', "\u20a3")
    CLP = new(45, 'CLP', "$")
    CNY = new(6, 'CNY',  "\uffe5")
    COP = new(27, 'COP', "$")
    CZK = new(44, 'CZK', "K\u010d")
    DKK = new(16, 'DKK', "kr.")
    EGP = new(19, 'EGP', "\u062c.\u0645.")
    EUR = new(2, 'EUR',  "\u20ac")
    FJD = new(18, 'FJD', "FJ$")
    GBP = new(4, 'GBP',  "\u00a3")
    HKD = new(14, 'HKD', "$")
    HUF = new(13, 'HUF', "Ft")
    IDR = new(22, 'IDR', "Rp")
    ILS = new(20, 'ILS', "\u20aa")
    INR = new(21, 'INR', "\u20b9")
    JOD = new(23, 'JOD', "\u062f.\u0627.")
    JPY = new(50, 'JPY', "\u00a5")
    KRW = new(49, 'KRW', "\u20a9")
    KWD = new(28, 'KWD', "\u062f.\u0643.")
    KZT = new(24, 'KZT', "\u0422")
    MDL = new(31, 'MDL', "lei")
    MXN = new(30, 'MXN', "$")
    MYR = new(29, 'MYR', "RM")
    NAD = new(32, 'NAD', "N$")
    NOK = new(35, 'NOK', "kr")
    NZD = new(33, 'NZD', "$")
    OMR = new(36, 'OMR', "\u0631.\u0639.")
    PLN = new(37, 'PLN', "z\u0142")
    QAR = new(26, 'QAR', "\u0631.\u0642.")
    RON = new(34, 'RON', "lei")
    RUB = new(3, 'RUB',  "\u20bd")
    SAR = new(38, 'SAR', "\u0631.\u0633.")
    SEK = new(46, 'SEK', "kr")
    SGD = new(39, 'SGD', "$")
    THB = new(5, 'THB',  "\u0e3f")
    TRY = new(41, 'TRY', "TL")
    TWD = new(40, 'TWD', "NT$")
    UAH = new(42, 'UAH', "\u20B4")
    USD = new(1, 'USD',  "$")
    ZAR = new(48, 'ZAR', "R")

    # старый
    ALL  = [USD, EUR, RUB]

    # новый
    ALL2 = [USD,EUR,THB,ARS,AUD,BGN,BHD,
            BRL,CAD,CHF,CLP,CNY,COP,
            CZK,DKK,EGP,FJD,GBP,
            HKD,HUF,IDR,ILS,INR,JOD,
            JPY,KRW,KWD,KZT,MDL,MXN,
            MYR,NAD,NOK,NZD,OMR,PLN,
            QAR,RON,RUB,SAR,SEK,SGD,
            TRY,TWD,UAH,AED,ZAR]
  end
end
