module Dicts
  class Locale < ::Dict
    attr_reader :symbol

    def initialize(id, index, symbol)
      @symbol = symbol
      super(id, index)
    end

    RU = new(1, 'ru', 'Русский')
    EN = new(2, 'en', 'English')
    EL = new(3, 'el', 'Ελληνικά')
    ES = new(4, 'es', 'Español')
    IT = new(5, 'it', 'Italiano')
    CS = new(6, 'cs', 'Český')
    FR = new(7, 'fr', 'Français')
    DE = new(8, 'de', 'Deutsch')
    ZH = new(9, 'zh', '中文')

    USED  = [EN, ES, IT, EL, DE, FR, CS, RU, ZH].freeze  # эти локали допустимы на сайте
    HAND  = [RU, EN].freeze                              # то, что заполняется вручную

    DEST  = EN                                           # из этой локали переводим во все остальные
    TRANS = USED - HAND                                  # в эти локали переводим

  end
end