module Dicts
  class Role < ::Dict
    ADMIN             = new 4,  'admin'
    CAPTAIN           = new 8,  'captain'
    BROKER            = new 10, 'broker'
    OWNER             = new 11, 'owner'
    DATA_CONTROLLER   = new 13, 'data_controller'
    CREW              = new 19, 'crew'
    BUILDER           = new 20, 'builder'
    AGENT             = new 23, 'agent'
    CENTRAL_AGENT     = new 24, 'central_agent'
    PORT              = new 31, 'port'
    LOCATION_DIRECTOR = new 32, 'location_director'
    SUPER_ADMIN       = new 33, 'super_admin'
    PHOTOGRAPHER      = new 40, 'photographer'
    WATER_WELLNES     = new 41, 'water_wellnes'
    TOUR_OPERATOR     = new 44, 'tour_operator'
    CLIENT            = new 45, 'client'
    DEALER            = new 52, 'dealer'
    REFIT_AND_REPAIR  = new 53, 'refit_and_repair'
  end


  class RoleCategory < ::Dict
    attr_reader :roles

    def initialize(id, index, roles)
      @roles = roles
      super(id, index)
    end

    RENT_AND_SALE = new 1, 'rent_and_sale', [
        ::Dicts::Role::CAPTAIN.id,
        ::Dicts::Role::BROKER.id,
        ::Dicts::Role::OWNER.id,
        ::Dicts::Role::CREW.id,
        ::Dicts::Role::BUILDER.id,
        ::Dicts::Role::AGENT.id,
        ::Dicts::Role::CENTRAL_AGENT.id,
        ::Dicts::Role::WATER_WELLNES.id,
        ::Dicts::Role::TOUR_OPERATOR.id,
        ::Dicts::Role::DEALER.id,
        ::Dicts::Role::PORT.id,
        ::Dicts::Role::REFIT_AND_REPAIR.id,
        ::Dicts::Role::PHOTOGRAPHER.id,
    ].freeze

    GETBOAT_TEAM  = new 2, 'get_boat_team', [
        ::Dicts::Role::DATA_CONTROLLER.id,
        ::Dicts::Role::LOCATION_DIRECTOR.id,

    ]

    SERVICE = new 3, 'service', [
        ::Dicts::Role::ADMIN.id,
        ::Dicts::Role::SUPER_ADMIN.id
    ].freeze

    USER = new 4, 'user', [
        ::Dicts::Role::CLIENT.id
    ].freeze

  end
end