module Custom
  module CurrencyHelper
    def currency_symbol(currency_index = nil)
      currency_index ||= cookies[:currency]
      Dicts::Currency.find_by_index(currency_index).symbol
    end

    def currency_for_label(options = {})
      options[:prefix] ||= ', '
      "#{options[:prefix]}#{currency_symbol}"
    end
    
    # @param name [Symbol, String] Например: `charter_1_day_high`
    #
    def currency_attribute_name(name, currency = nil)
      currency ||= cookies[:currency]
      Currency.attribute_name(currency, name)
    end

    # 12 USD -> $ 12.00, EUR -> €,...
    require_relative 'select_helper'
    include ::Custom::SelectHelper
    def num_to_cur(val, iso_code, locale)
      unit = Dicts::Currency.find_by_index(iso_code).symbol
      number_to_currency(val, unit: unit, locale: locale)
    end
  end
end