module Custom
  module PriceHelper

    # @param [Boat] object
    #
    def price_discount(object, attr)
      price    = object.attributes[currency_attribute_name(attr)]
      discount = object.attributes["#{attr}_discount"]
      return ''    if price.nil?

      return price if discount.nil?

      price - (price / 100 * discount)
    end

    # @param [Boat] object
    #
    def price_format(object, attr, options = {})
      price = options[:discounted] ? price_discount(object, attr) : object.attributes[currency_attribute_name(attr, options[:currency])]
      return '' if price.blank?

      unit  = currency_symbol options[:currency]
      price = number_to_currency(price, unit: unit).to_s
      price = price            + options[:postfix] if options[:postfix]
      price = options[:prefix] + price             if options[:prefix]
      price
    end
  end
end