module Custom
  module SelectHelper
    def collection_name_by_id(collection, id)
      return false if collection.empty?

      element = collection.find { |hash| hash[:id] == id }
      element.try(:fetch, :name)
    end

    def collection_for_select(collection, name, id, options = {})
      return [] unless collection.is_a?(Array)

      collection = if options[:collection_is_not_hash]
                     collection.map do |h|
                       field = h.try(name)
                       label = options[:i18n].present? ? options[:i18n][field] : field.capitalize
                       [ label, h.try(id) ]
                     end
                   else
                     collection.map { |h| [ h[name], h[id] ] }
                   end
      collection.unshift [options[:blank_value_label],''] if options[:blank_value_label]
      collection = options_for_select(collection, options[:value]) if options[:options_for_select].present?
      collection
    end

  end
end