module Site
  module TimeHelper

    def next_hour(value)
      value == 23 ? 0 : value + 1
    end

    # Вернёт отформатированную строку с датой ~ от локали.
    # @param with_time [Boolean] Если true - вернёт и время
    #
    def format_date(date, locale = :en, with_time = false, with_html = false)
      date.strftime locale_date_format(locale, with_time, with_html)
    end

    # В зависимости от локали выдаст соответствующий формат для отображения дат.
    # https://en.wikipedia.org/wiki/Date_format_by_country
    # @param with_time [Boolean] Если true - вернёт и время
    #
    def locale_date_format(locale = :en, with_time = false, with_html = false)
      res = case locale.to_s
              when 'en'
                with_html ? '<span class="year">%Y</span>/<span class="month">%m</span>/<span class="day">%d</span>' : '%Y/%m/%d'
              when 'ru'
                with_html ? '<span class="day">%d</span>.<span class="month">%m</span>.<span class="year">%Y</span>' : '%d/%m/%Y'
              else
                '%Y/%m/%d'
            end

      res += ' %H:%M' if with_time
      res
    end
  end
end