module Accounts
  class CentralAgentAccountRepository

    # todo-my: перевести в self.
    def create_account(user)
      return unless user
      return if user.accounts.central_agents.any?

      account = ::Account.new(type_id: ::Dictionaries::AccountType::CENTRAL_AGENT)
      central = ::Accounts::CentralAgent.new(account: account)

      account.user   = user
      account.name   = user.name.to_s
      account.active = true
      user.is_notify = true

      ActiveRecord::Base.transaction do
        account.save
        central.save
        user.save
        ::Accounts::CentralAgents::AddStatus.call account.id
      end

      central
    end

    # todo-my: перевести в self.
    def destroy_account(user)
      return unless user
      return unless user.accounts.central_agents.any?

      account = user.accounts.central_agents.first
      central = account.central_agent

      ActiveRecord::Base.transaction do
        central.destroy
        account.destroy
      end
    end

    def self.fetch_or_create(user)
      return unless user
      return user.accounts.central_agents.first.central_agent if user.accounts.central_agents.any?
      new.create_account(user)
    end
  end
end
