# frozen_string_literal: true
module Accounts
  module CentralAgents
    class AddStatus
      SQL = 'INSERT INTO %{table}(agent_account_id, account_id, value, created_at) VALUES(%{caid}, %{aid}, \'%{val}\', NOW())'

      def self.call(central_agent_account_id, account_id = 1, status_index = ::Dicts::Accounts::CentralAgentStatus::NONE.index)
        sql = SQL % {
            table: CentralAgentStatus.table_name,
            caid:  central_agent_account_id,
            aid:   account_id,
            val:   status_index
        }
        ActiveRecord::Base.connection.execute sql
      end
    end
  end
end
