module Accounts
  class CentralAgentSerializer < AbstractSerializer
    class << self
      def available_attributes
        %i[
          email
          phone
          name
        ]
      end

      def email(central_agent)
        { email: central_agent.account.user.email }
      end

      def phone(central_agent)
        { phone: central_agent.account.user.phone }
      end

      def name(central_agent)
        { name: central_agent.account.user.name }
      end
    end
  end
end
