class BoatPriceSerializer < AbstractSerializer

  class << self
    def available_attributes
      %i[season uom duration currency value discount]
    end

    def season(boat_price)
      {
          season: {
              id:     boat_price.season_id,
              index:  ::Dicts::CharterSeason.find(boat_price.season_id).index
          }
      }
    end

    # час, день, неделя, месяц
    def uom(boat_price)
      {
          uom: {
              id:    boat_price.uom_id,
              index: ::Dicts::CharterUom.find(boat_price.uom_id).index
          }
      }
    end

    def duration(boat_price)
      { duration: boat_price.duration }
    end

    def currency(boat_price)
      bp = ::Dicts::Currency.find(boat_price.currency_id)

      {
          currency: {
              id:     bp.id,
              index:  bp.index,
              symbol: bp.symbol
          }
      }
    end

    # цена за указанный период
    def value(boat_price)
      { value: sprintf('%d', boat_price.value) }
    end

    def discount(boat_price)
      { discount: sprintf('%.2f', boat_price.discount) }
    end

    # TODO:: прояснить надобность, проработать тему
    def is_orig(boat_price)
      { is_orig: boat_price.is_orig }
    end

  end
end