class BoatSalePriceSerializer < AbstractSerializer

  class << self
    def available_attributes
      %i[currency value discount]
    end

    def currency(sale_price)
      currency = ::Dicts::Currency.find(sale_price.currency_id)

      {
          currency: {
              id:     currency.id,
              index:  currency.index,
              symbol: currency.symbol
          }
      }
    end

    # цена за указанный период
    def value(sale_price)
      { value: sprintf('%d', sale_price.value) }
    end

    def discount(sale_price)
      { discount: sprintf('%.2f', sale_price.discount) }
    end
  end
end