class CharterPriceSerializer < AbstractSerializer

  class << self
    def available_attributes
      %i[currency value]
    end

    def currency(charter_price)
      currency = ::Dicts::Currency.find(charter_price.currency_id)

      {
          currency: {
              id:     currency.id,
              index:  currency.index,
              symbol: currency.symbol
          }
      }
    end

    def value(charter_price)
      { value: sprintf('%d', charter_price.value) }
    end

  end
end