module Configs
  module Boats
    class BoatPrices
      # список ценовых (продажа/аренда) атрибутов Лодки
      def self.attributes(price_attributes = ::Dictionaries::BoatCharterAttribute::ALL)
        attributes = []
        ::Dicts::Currency::ALL.each do |currency|
          price_attributes.map do |attr|
            field = Currency.attribute_name currency.index, attr
            next unless field

            attributes << field.to_sym
          end
          field = Currency.attribute_name currency.index, :sale_price
          attributes << field.to_sym
        end
        if block_given?
          attributes.each do |attribute|
            yield attribute
          end
        else
          attributes
        end
      end
    end
  end
end