module Configs
  module Boats
    class BoatPricesDiscount
      #
      # список атрибутов лодки, в которых указана скидка в процентах
      #
      def self.attributes(price_attributes = ::Dictionaries::BoatCharterAttribute::ALL)
        # собираем имена вида: charter_1_hour_high_discount,...
        attributes = []
        price_attributes.map do |attr|
          field = '%s_discount' % attr
          next unless field

          attributes << field.to_sym
        end

        # особняком добавляем имя атрибута sale_price_discount
        field = '%s_discount' % :sale_price
        attributes << field.to_sym

        if block_given?
          attributes.each do |attribute|
            yield attribute
          end
        else
          attributes
        end
      end
    end
  end
end