module Lease
  class RequestInfoSerializer < ::AbstractSerializer
    class << self
      def serialize(model, attributes:, opts: {})
        super
      end

      def available_attributes
        %i[
          id
          uuid
          operator
          amount
          currency
          external_transaction_id
          state
          created_at
          updated_at
        ]
      end

      def id(request_info)
        { id: request_info.id }
      end

      def uuid(request_info)
        { uuid: request_info.uuid }
      end

      def operator(request_info)
        {
          operator: {
            id:    request_info.operator.id,
            index: request_info.operator.type_index
          }
        }
      end

      def amount(request_info)
        { amount: request_info.amount }
      end

      def currency(request_info)
        { currency: request_info.currency }
      end

      def external_transaction_id(request_info)
        { external_transaction_id: request_info.external_transaction_id }
      end

      def state(request_info)
        { state: request_info.state }
      end

      def created_at(request_info)
        { created_at: request_info.created_at }
      end

      def updated_at(request_info)
        { updated_at: request_info.updated_at }
      end
    end
  end
end
