module Lib
  module Boats
    class Dimensions
      extend ::Custom::DimensionHelper
      extend ::Custom::SelectHelper

      # @param [String]  uom: ft, meters
      # @return [String] '78.7 ft', '20 m'
      #
      def self.boatlength(boat, uom = nil)
        attr = dimension_attribute_name(:boat_length_metrics, uom)
        '%s %s' % [boat.attributes[attr], dimension_symbol(uom)]
      end

      def self.boatbeam(boat, uom = nil)
        attr = dimension_attribute_name(:boat_beam_metrics, uom)
        '%s %s' % [boat.attributes[attr], dimension_symbol(uom)]
      end

      def self.boatdraft(boat, uom = nil)
        attr = dimension_attribute_name(:boat_draft_metrics, uom)
        '%s %s' % [boat.attributes[attr], dimension_symbol(uom)]
      end
    end
  end
end
