module CentralAgent
  class SaveBoatService

    attr_reader :errors, :boat

    def initialize
      _reset_ivars
    end

    # @param [Hash] boat_params
    # @param [Hash] cookies  example: {... "currency"=>"USD", "dimension"=>"ft", "volume"=>"liters", "business"=>"rent", "language"=>"en"}
    #
    def perform(boat_params, cookies, current_user, state: Boat::STATE_PREMODERATED)
      _reset_ivars

      @schema = ::Schemas::CentralAgent::SaveBoatSchema.new boat_params.dup                                             # проверяем параметры, пришедшие с формы
      unless @schema.valid?
        @errors = @schema.errors.messages
        return false
      end

      if boat_params[:id].present?
        boat = _update_boat(@schema.attributes, cookies)
      else
        boat = _create_boat(@schema.attributes, cookies, current_user, state)
      end

      @boat = boat
      true
    end

    private

    def _create_boat(boat_params, cookies, current_user, state)                                                         # TODO:: проверить и доработать при необходимости (ref /home/scout/git/get-the-boat/app/services/boat_register_service.rb)
      prms = _fuck_params boat_params

      boat = Boat.new
      boat.assign_attributes prms
      boat.state = state

      _handle_boat_attributes(boat, cookies)

      ActiveRecord::Base.transaction do
        boat.users << current_user

        boat.send :set_slug
        boat.save validate: false
        boat.update_attribute(:boat_photo_id, boat.boat_photos.first.id)                                                # TODO:: реализовать назначение главного фото (пока же на скорую руку делаем первую фотку главной)
        _save_prices boat
      end

      boat
    end

    def _update_boat(boat_params, cookies)                                                                              # TODO:: реализовать назначение главного фото (в админке, например, приходит такое: "boat"=>{"boat_photo_id"=>"41434"})
      # _fuck_params - подгоняем под active_record (перегоняем массив в хэш)
      #boat_locs2                       = boat_params[:boat_locations_attributes].compact.map { |attr| [attr[:id], attr] }.to_h
      #prms                             = boat_params.except(:rent_prices, :sale_price, :boat_locations_attributes)      # с формы из кабинета, в отличии от админки, приходит длина в виде "boat_length_metrics_ft" => "12.0"
      #prms[:boat_locations_attributes] = boat_locs2
      prms = _fuck_params boat_params

      boat = Boat.find boat_params[:id]
      boat.assign_attributes prms

      _handle_boat_attributes(boat, cookies)

      ActiveRecord::Base.transaction do
        boat.send :set_slug
        boat.save validate: false
        _save_prices boat
        boat.cancel if boat.state == ::Boat::STATE_APPROVED.to_s                                                        # кто знает, что там наизменял агент в своей лодке, вдруг фотки с телефонами загрузил?
      end

      boat
    end

    # boat_params - это атрибуты схемы
    def _fuck_params(boat_params)
      # подгоняем под active_record (перегоняем массив в хэш)
      boat_locs2                       = boat_params[:boat_locations_attributes].compact.map { |attr| [(attr[:id] || -(rand*1000).to_i), attr] }.to_h
      prms                             = boat_params.except(:rent_prices, :sale_price, :boat_locations_attributes, :main_boat_photo_id)      # с формы из кабинета, в отличии от админки, приходит длина в виде "boat_length_metrics_ft" => "12.0"
      prms[:boat_photo_id]             = boat_params[:main_boat_photo_id]
      prms[:boat_locations_attributes] = boat_locs2
      prms
    end

    def _handle_boat_attributes(boat, cookies)
      dimension_service = ::DimensionService.new(boat)                                                                    # присланные измерения переведём в другие единицы измерения
      dimension_service.calculate_boat_attributes(cookies[:dimension])

      # volume_service = VolumeService.new(boat)
      # volume_service.calculate_boat_attributes(cookies[:volume])
    end

    # сохраним цены аренды и цену продажи
    def _save_prices(boat)
      service = ::Boats::BoatPricesSaveService.new
      result  = service.perform boat, @schema.attributes[:rent_prices]

      if result && boat.for_rent != service.is_for_rent                                                                 # result = true - обязательное условие
        boat.update_columns for_rent: service.is_for_rent
      end

      service = ::Boats::BoatSalePricesSaveService.new
      result  = service.perform boat.id, @schema.attributes[:sale_price]

      if result && boat.for_sale != service.is_for_sale                                                                 # result = true - обязательное условие
        boat.update_columns for_sale: service.is_for_sale
      end
    end

    def _reset_ivars
      @errors = { }
      @boat   = nil
    end
  end
end