class DimensionService

  def initialize model
    @model = model
  end

  def calculate_boat_attributes default_dimension

    attributes = [:boat_length_metrics, :boat_beam_metrics, :boat_draft_metrics, :boat_gross_tonage]

    available_dimensions(default_dimension).each do |available_dimension|

      # puts "#{available_dimension} #{default_dimension}"
      dimension_value = Dimension::COMPARISON[default_dimension.to_sym][available_dimension.to_sym]

      attributes.each do |attribute|
        attribute_dimension         = attribute.to_s + "_#{available_dimension}"
        attribute_default_dimension = attribute.to_s + "_#{default_dimension}"
        default_dimension_value     = @model.attributes[attribute_default_dimension.downcase]

        if default_dimension_value
          calculated_dimension = default_dimension_value * dimension_value
          @model.send("#{attribute_dimension}=", calculated_dimension)
          # puts "#{default_dimension_value} #{default_dimension} is #{calculated_dimension} #{available_dimension}"
        else
          @model.send("#{attribute_dimension}=", nil)
        end
      end
    end

  end

  def available_dimensions default_dimension
    available_dimensions = []
    I18n::t('static.dimensions').select do |dimension|
      next if dimension[:id] == default_dimension
      available_dimensions << dimension[:id]
    end
    available_dimensions
  end

end
