module Sale
  #
  # Когда юзер предлагает свою цену продажи лодки (создаётся заявка),
  # создается набор цен в разных валютах, подвязанных к созданной заявке.
  #
  class InquiryAskedPricesSaveService < ::AbstractPricesService
    def self.perform(sale_inquiry_id, asked_price)
      new.perform sale_inquiry_id, asked_price
    end

    def perform(sale_inquiry_id, asked_price = nil)
      _reset_ivars
      return false if asked_price.nil?

      ap              = asked_price.dup
      ap[:inquiry_id] = sale_inquiry_id
      ap[:is_orig]    = true
      ap[:value]      = ap[:value].is_a?(String) ? ap[:value].split(/[, ]/).join : ap[:value].to_i                      # с формы может прийти строка, сгруппированная по разрадям, вида "100,100,222" + тут же превращаем nil в 0
      ap[:created_at] = '\'%s\'' % Time.now.to_s(:db)
      _build_other ap

      filtered2 = @built_prices + [ap]
      _save filtered2
      true
    end

    private

      def _model
        Sale::InquiryAskedPrice
      end

      def _fields_for_create
        @fields_for_create ||= %w'inquiry_id currency_id value is_orig created_at'
      end
  end
end
