module Users
  class GenerateEmailTokenService
    def self.call(user, email_token_subj_id, bid_id = nil)
      user_email_token            = ::UserEmailToken.new user: user
      user_email_token.token      = ::TokenGenerator.generate_token
      user_email_token.expires_at = Time.now + 1.week
      user_email_token.subj_id    = email_token_subj_id
      user_email_token.save!

      create_bid_link(user_email_token.id, bid_id) if needed_types.include? email_token_subj_id

      user_email_token.token
    end

    # создадим связку Токена с Предложением,
    # если токен генерится для ссылки на Предложение в Кабинете или на просмотр Лодки на сайте,
    # которая вставляется в письмо о новом Предложении, отправляемого Клиенту
    #
    # Делаем это только для того, чтобы найти уже сгенерированный токен,
    # зная id Предложения,
    # чтобы повторно его использовать (т.е. вставить в письмо-уведомление о предоставленной скидке)
    #
    def self.create_bid_link(user_email_token_id, bid_id)
      return unless bid_id

      opts = {
        token_id: user_email_token_id,
        bid_id:   bid_id
      }
      sql  = 'INSERT IGNORE INTO user_email_tokens_bids(token_id, bid_id) VALUES(%{token_id}, %{bid_id})' % opts
      ActiveRecord::Base.connection.execute(sql)
    end

    # для таких типов генерим связку токена с Предложением
    def self.needed_types
      [::Dicts::EmailTokenSubj::TO_CLIENT_NEW_BID.id, ::Dicts::EmailTokenSubj::TO_CLIENT_NEW_BID_BOAT.id]
    end
  end
end