module Boats
  # определяем, указана ли хоть какая-нибудь цена продажи?
  #
  module IsForSell
    module_function

    # @param [Boat] record
    # @return [TrueClass || FalseClass]
    #
    def check?(record)
      ::Dicts::Currency::ALL.map do |currency|
        field = Currency.attribute_name currency.index, 'sale_price'
        value = record.send field
        # noinspection RubySimplifyBooleanInspection
        !!(value&.>0)
      end.any?
    end
  end
end
