class CurrencyPresenceValidator < ActiveModel::EachValidator
  def validate_each(record, attribute, value)
    unless record.currency
      raise ArgumentError, 'record.currency does not exist'
    end
    available_currencies = I18n::t('static.currencies').map{|currency| currency[:id]}
    record_currency = record.currency.upcase
    if available_currencies.include? record_currency
      attribute_currency = attribute.to_s.split('_')[-1].upcase
      if record_currency == attribute_currency && record.attributes[attribute.to_s].nil?
        record.errors[attribute] << "can't be blank!"
      end
    else
      raise ArgumentError, 'Model record.currency does not exist in I18n::t(\'static.currencies\')'
    end
  end
end
