class DimensionPresenceValidator < ActiveModel::EachValidator
  def validate_each(record, attribute, value)
    unless record.dimension
      raise ArgumentError, 'record.dimension does not exist'
    end
    available_dimensions = I18n::t('static.dimensions').map{|dimension| dimension[:id]}
    record_dimension = record.dimension.downcase
    if available_dimensions.include? record_dimension
      attribute_dimension = attribute.to_s.split('_')[-1].downcase
      if record_dimension == attribute_dimension && record.attributes[attribute.to_s].nil?
        record.errors[attribute] << "can't be blank!"
      end
    else
      raise ArgumentError, 'Model record.dimension does not exist in I18n::(\'static.dimensions\')'
    end
  end
end
